# Generated by Django 4.2.1 on 2023-05-17 20:23
from uuid import UUID

from django.db import migrations, models

ABSENCE_TYPE_CTO = UUID("13d05b0f-f121-4eae-ad1a-96d237c83e1b")


def update_absence_types(apps, schema_editor):
    AbsenceType = apps.get_model("timetracker", "AbsenceType")
    for absence_type in AbsenceType.objects.all():
        absence_type.counts_as_negative_working_time = (
            absence_type.uuid == ABSENCE_TYPE_CTO
        )
        absence_type.save()

    Tenant = apps.get_model("common", "Tenant")
    Absence = apps.get_model("timetracker", "Absence")
    for absence_type in AbsenceType.objects.filter(tenant__isnull=True):
        for tenant in Tenant.objects.all():
            new_type = AbsenceType.objects.create(
                label=absence_type.label,
                color=absence_type.color,
                active=absence_type.active,
                needs_approval=absence_type.needs_approval,
                counts_for_time_accounting=absence_type.counts_for_time_accounting,
                icon=absence_type.icon,
                tenant=tenant,
            )
            for absence in Absence.objects.filter(
                absence_type=absence_type, employee__tenant=tenant
            ):
                absence.absence_type = new_type
                absence.save()
        absence_type.delete()


class Migration(migrations.Migration):
    dependencies = [
        ("timetracker", "0015_timetrackertenant_alter_absence_options_and_more"),
    ]

    operations = [
        migrations.RemoveField(
            model_name="absencetype",
            name="public",
        ),
        migrations.AddField(
            model_name="absencetype",
            name="counts_for_time_accounting",
            field=models.BooleanField(
                default=False,
                help_text="if checked, this type is counted as negative hours for time accounting. If not, it is treated neutrally.",
            ),
        ),
        migrations.RunPython(update_absence_types, migrations.RunPython.noop),
    ]
